
int storePin = 10; 
int shiftPin = 13; 
int dataPin = 11; 

const int num_rows = 8;
const int num_cols = 12;

int rows = 0;
int cols = 0;
int receivedData;
  
int bitshift[] = {0,0,0,0,0,0,0,0,   //1. SR 
                  0,0,0,0,0,0,0,0,   //2. SR
                  0,0,0,0,0,0,0,0,   //3. SR
                  0,0,0,0,0,0,0,0,   //4. SR
                  0,0,0,0,0,0,0,0,   //5. SR
                  0,0,0,0,0,0,0,0};   //6. SR
 const int LEDS_R[] = {10,13,27,24,37,30,21,18,29,34,43,40};                                                                   //Ausgangspinnummerierung für Rote LEDS
 const int LEDS_G[] = {8,11,14,26,39,36,23,20,17,28,33,42};                                                                    //Ausgangspinnummerierung für Grüne LEDS
 const int LEDS_B[] = {9,12,15,25,38,31,22,19,16,35,32,41};                                                                    //Ausgangspinnummerierung für Blaue LEDS
 const int zeilen[] = {0,1,2,3,4,5,6,7};                                                                                       //Ausgangspinnummerierung für Zeilen

 int bytearray[num_rows][num_cols] = {{0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0},
                                    {0,0,0,0,0,0,0,0,0,0,0,0}};

void setup() {

  pinMode(storePin, OUTPUT);
  pinMode(shiftPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  Serial.begin(38400);
  Serial.setTimeout(1);  
}
void loop() { 
  while (Serial.available() > 0 ) {
      read_data();
    } 
  Bitarraydarstellen(); 
}

int Anzeige (int r1, int c1) {    //Anzeige durch 2D Array
int d;

d = bytearray[r1][c1];
return d;
}
  
void Bitarraydarstellen() { 
int arrayval1;

  for (int r = 0; r < num_rows; r++) {
    One_Frame(bitshift);
    delay(0.5);
    for (int BitC = 0; BitC < 48; BitC ++) {                   //Rückstellen der Bitsfolge    
            bitshift[BitC] = 0;}   
      for (int c = 0; c <num_cols; c++) {
        arrayval1 = Anzeige(r,c);                              //Funktionsaufruf Anzeige, Rückgabewert Array Wert an Stelle r und c.      
        if (arrayval1 == 1) {
        bitSet(bitshift[(LEDS_R[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0);}        
        if (arrayval1 == 2) {      
        bitSet(bitshift[(LEDS_G[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0); }                
        if (arrayval1 == 3) {
        bitSet(bitshift[(LEDS_B[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0); }                 
        if (arrayval1 == 4) {
        bitSet(bitshift[(LEDS_R[c])], 0);
        bitSet(bitshift[(LEDS_G[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0); }       
        if (arrayval1 == 5) {     
        bitSet(bitshift[(LEDS_B[c])], 0);
        bitSet(bitshift[(LEDS_G[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0); }       
        if (arrayval1 == 6) {
        bitSet(bitshift[(LEDS_R[c])], 0);
        bitSet(bitshift[(LEDS_B[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0); }       
        if (arrayval1 == 7) {
        bitSet(bitshift[(LEDS_R[c])], 0);
        bitSet(bitshift[(LEDS_G[c])], 0);
        bitSet(bitshift[(LEDS_B[c])], 0);
        bitSet(bitshift[(zeilen[r])], 0); }       
         }                      
          }
      } 
void read_data() { 
   
 int receivedData = Serial.read();
 bytearray[rows][cols] = receivedData;
 cols = cols + 1;
 
 if (cols> 11) {
  cols = 0;
  rows = rows + 1;
 }
 if (rows>7) {
  rows = 0;   
 }
}
